# Test_Super_Repo

This is a test repo. It is the super repo holding submodules.
 
## Getting started

Get the newest version of git.

An error of `git version 2.25.1`:

```shell
$ git submodule update --remote --merge "payload/db1"
fatal: Needed a single revision
Konnte aktuellen Commit von origin/master in Submodul-Pfad
'payload/db1' nicht finden.
```

This is fixed with update to `git version 2.37.3

```shell
sudo add-apt-repository ppa:git-core/ppa -y
sudo apt-get update
sudo apt-get install git -y
```

## Selectively INIT and UPDATE submodules

Selective submodule installation:

`git submodule update --init -- payload/db1`

This clones the pinned commit in `test_super_repo/.git/modules/payload/db1/ORIG_HEAD`.

To update to the HEAD of the submodule, run:

`git submodule update --remote --merge "payload/db1"`

This causes the state `HEAD losgelöst von 9b4fbd0`

If those updates to the submodule "payload/db1" are commited and pushed to test_super_repo, ORIG_HEAD wil be updated to the HEAD of "payload/db1"

## git LFS

```shell
$ wget https://gitlab.bfr.berlin/hbrendebach/test_sub_repo_1/-/raw/main/sample.bin -O sample.bin.wget
$ find . -name "sample.bin*" -exec md5sum {} \;
03fa92402aa166ec2a36f4014b8e78a8  ./payload/db1/sample.bin
03fa92402aa166ec2a36f4014b8e78a8  ./sample.bin.wget
```

```shell
$ wget https://gitlab.bfr.berlin/hbrendebach/test_sub_repo_1/-/raw/main/sample.psd -O sample.psd.wget
$ find . -name "sample.psd*" -exec md5sum {} \;
bf074b212163f4337466fee1b83ff4d4  ./payload/db1/sample.psd
63cfc9bdf6b7db6006df6400dfb38ac7  ./sample.psd.wget
$ cat payload/db1/sample.psd 
version https://git-lfs.github.com/spec/v1
oid sha256:cc8e17046b3d5e4727f9e35a813986c87c33f5caa0ada6c2ce4d4b4453a3553c
size 1048576
```

**Take-Home-Message:** If you don't have [git-lfs installed](https://git-lfs.github.com/), pulled files only contain pointers.
